<template>
  <div>
    <div class="container mt-3">
      <div class="panel panel-primary">
        <div class="panel-heading row">
          <h2 class="col-9">Add Company</h2>
        </div>
        <div class="panel-body">
          <form @submit.prevent="addCompany">
            <div class="form-group mt-2">
              <label>Company State</label>
              <select
                class="form-control"
                v-model="company.state_abbr"
                required
              >
                <option value="AC">Acre</option>
                <option value="AL">Alagoas</option>
                <option value="AP">Amapá</option>
                <option value="AM">Amazonas</option>
                <option value="BA">Bahia</option>
                <option value="CE">Ceará</option>
                <option value="DF">Distrito Federal</option>
                <option value="ES">Espírito Santo</option>
                <option value="GO">Goiás</option>
                <option value="MA">Maranhão</option>
                <option value="MT">Mato Grosso</option>
                <option value="MS">Mato Grosso do Sul</option>
                <option value="MG">Minas Gerais</option>
                <option value="PA">Pará</option>
                <option value="PB">Paraíba</option>
                <option value="PR">Paraná</option>
                <option value="PE">Pernambuco</option>
                <option value="PI">Piauí</option>
                <option value="RJ">Rio de Janeiro</option>
                <option value="RN">Rio Grande do Norte</option>
                <option value="RS">Rio Grande do Sul</option>
                <option value="RO">Rondônia</option>
                <option value="RR">Roraima</option>
                <option value="SC">Santa Catarina</option>
                <option value="SP">São Paulo</option>
                <option value="SE">Sergipe</option>
                <option value="TO">Tocantins</option>
                <option value="EX">Estrangeiro</option>
              </select>
            </div>
            <div class="form-group mt-2">
              <label>Name</label>
              <div v-if="companyNameError" class="text-danger">
                <p
                  v-for="error in companyNameError"
                  :key="error"
                  class="small my-0 mb-1"
                >
                  {{ error }}
                </p>
              </div>
              <input
                type="text"
                class="form-control"
                v-model="company.name"
                @input="companyNameError = []"
                required
              />
            </div>
            <div class="form-group mt-2">
              <label>CNPJ</label>
              <div v-if="companyCNJPError" class="text-danger">
                <p
                  v-for="error in companyCNJPError"
                  :key="error"
                  class="small my-0 mb-1"
                >
                  {{ error }}
                </p>
              </div>
              <input
                type="number"
                class="form-control"
                v-model="company.CNPJ"
                @input="companyCNJPError = []"
              />
            </div>
            <button type="submit" class="btn btn-primary mt-3">Add</button>
          </form>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import cnpjValidation from "../cnpjValidation.js";
export default {
  data() {
    return {
      company: {},
      companyNameError: [],
      companyCNJPError: [],
    };
  },
  methods: {
    addCompany() {
      if (this.validateCompany()) {
        this.axios
          .post("http://localhost/api/companies", {
            state_abbr: this.company.state_abbr,
            name: this.company.name,
            CNPJ: this.company.CNPJ,
          })
          .then((response) => this.$router.push({ name: "companies" }))
          .catch((err) => console.log(err))
          .finally(() => (this.loading = false));
      }
    },
    validateCompany() {
      if (this.company.name.length > 254) {
        if (this.companyNameError.length == 0) {
          this.companyNameError.push("- Must be less than 255 characters ");
        }
      }
      if (!this.company.CNPJ || !cnpjValidation(this.company.CNPJ)) {
        if (this.companyCNJPError.length == 0) {
          this.companyCNJPError.push("- This CNPJ is invalid.");
        }
      }
      if (
        this.companyNameError.length > 0 ||
        this.companyCNJPError.length > 0
      ) {
        return false;
      }
      return true;
    },
  },
};
</script>
